<?php

declare(strict_types=1);

namespace App\Policies;

use App\Models\Cooperation;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class CooperationPolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:Cooperation');
    }

    public function view(AuthUser $authUser, Cooperation $cooperation): bool
    {
        return $authUser->can('View:Cooperation');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:Cooperation');
    }

    public function update(AuthUser $authUser, Cooperation $cooperation): bool
    {
        return $authUser->can('Update:Cooperation');
    }

    public function delete(AuthUser $authUser, Cooperation $cooperation): bool
    {
        return $authUser->can('Delete:Cooperation');
    }

    public function restore(AuthUser $authUser, Cooperation $cooperation): bool
    {
        return $authUser->can('Restore:Cooperation');
    }

    public function forceDelete(AuthUser $authUser, Cooperation $cooperation): bool
    {
        return $authUser->can('ForceDelete:Cooperation');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:Cooperation');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:Cooperation');
    }

    public function replicate(AuthUser $authUser, Cooperation $cooperation): bool
    {
        return $authUser->can('Replicate:Cooperation');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:Cooperation');
    }
}
